# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_deb.configuration import Configuration


class DebPackageIndexResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'pulp_href': 'str',
        'pulp_created': 'datetime',
        'artifacts': 'object',
        'component': 'str',
        'architecture': 'str',
        'relative_path': 'str'
    }

    attribute_map = {
        'pulp_href': 'pulp_href',
        'pulp_created': 'pulp_created',
        'artifacts': 'artifacts',
        'component': 'component',
        'architecture': 'architecture',
        'relative_path': 'relative_path'
    }

    def __init__(self, pulp_href=None, pulp_created=None, artifacts=None, component=None, architecture=None, relative_path=None, local_vars_configuration=None):  # noqa: E501
        """DebPackageIndexResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._pulp_href = None
        self._pulp_created = None
        self._artifacts = None
        self._component = None
        self._architecture = None
        self._relative_path = None
        self.discriminator = None

        if pulp_href is not None:
            self.pulp_href = pulp_href
        if pulp_created is not None:
            self.pulp_created = pulp_created
        self.artifacts = artifacts
        if component is not None:
            self.component = component
        if architecture is not None:
            self.architecture = architecture
        if relative_path is not None:
            self.relative_path = relative_path

    @property
    def pulp_href(self):
        """Gets the pulp_href of this DebPackageIndexResponse.  # noqa: E501


        :return: The pulp_href of this DebPackageIndexResponse.  # noqa: E501
        :rtype: str
        """
        return self._pulp_href

    @pulp_href.setter
    def pulp_href(self, pulp_href):
        """Sets the pulp_href of this DebPackageIndexResponse.


        :param pulp_href: The pulp_href of this DebPackageIndexResponse.  # noqa: E501
        :type: str
        """

        self._pulp_href = pulp_href

    @property
    def pulp_created(self):
        """Gets the pulp_created of this DebPackageIndexResponse.  # noqa: E501

        Timestamp of creation.  # noqa: E501

        :return: The pulp_created of this DebPackageIndexResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._pulp_created

    @pulp_created.setter
    def pulp_created(self, pulp_created):
        """Sets the pulp_created of this DebPackageIndexResponse.

        Timestamp of creation.  # noqa: E501

        :param pulp_created: The pulp_created of this DebPackageIndexResponse.  # noqa: E501
        :type: datetime
        """

        self._pulp_created = pulp_created

    @property
    def artifacts(self):
        """Gets the artifacts of this DebPackageIndexResponse.  # noqa: E501

        A dict mapping relative paths inside the Content to the correspondingArtifact URLs. E.g.: {'relative/path': '/artifacts/1/'  # noqa: E501

        :return: The artifacts of this DebPackageIndexResponse.  # noqa: E501
        :rtype: object
        """
        return self._artifacts

    @artifacts.setter
    def artifacts(self, artifacts):
        """Sets the artifacts of this DebPackageIndexResponse.

        A dict mapping relative paths inside the Content to the correspondingArtifact URLs. E.g.: {'relative/path': '/artifacts/1/'  # noqa: E501

        :param artifacts: The artifacts of this DebPackageIndexResponse.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and artifacts is None:  # noqa: E501
            raise ValueError("Invalid value for `artifacts`, must not be `None`")  # noqa: E501

        self._artifacts = artifacts

    @property
    def component(self):
        """Gets the component of this DebPackageIndexResponse.  # noqa: E501

        Component of the component - architecture combination.  # noqa: E501

        :return: The component of this DebPackageIndexResponse.  # noqa: E501
        :rtype: str
        """
        return self._component

    @component.setter
    def component(self, component):
        """Sets the component of this DebPackageIndexResponse.

        Component of the component - architecture combination.  # noqa: E501

        :param component: The component of this DebPackageIndexResponse.  # noqa: E501
        :type: str
        """

        self._component = component

    @property
    def architecture(self):
        """Gets the architecture of this DebPackageIndexResponse.  # noqa: E501

        Architecture of the component - architecture combination.  # noqa: E501

        :return: The architecture of this DebPackageIndexResponse.  # noqa: E501
        :rtype: str
        """
        return self._architecture

    @architecture.setter
    def architecture(self, architecture):
        """Sets the architecture of this DebPackageIndexResponse.

        Architecture of the component - architecture combination.  # noqa: E501

        :param architecture: The architecture of this DebPackageIndexResponse.  # noqa: E501
        :type: str
        """

        self._architecture = architecture

    @property
    def relative_path(self):
        """Gets the relative_path of this DebPackageIndexResponse.  # noqa: E501

        Path of file relative to url.  # noqa: E501

        :return: The relative_path of this DebPackageIndexResponse.  # noqa: E501
        :rtype: str
        """
        return self._relative_path

    @relative_path.setter
    def relative_path(self, relative_path):
        """Sets the relative_path of this DebPackageIndexResponse.

        Path of file relative to url.  # noqa: E501

        :param relative_path: The relative_path of this DebPackageIndexResponse.  # noqa: E501
        :type: str
        """

        self._relative_path = relative_path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DebPackageIndexResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DebPackageIndexResponse):
            return True

        return self.to_dict() != other.to_dict()
